import { ObjectID } from "mongodb";
export declare type CreateResult = {
    ok: boolean;
    id: ObjectID;
};
export declare type UpdateResult = {
    ok: boolean;
    id: ObjectID;
};
export declare type DeleteResult = {
    ok: boolean;
};
export interface IOperation<T> {
    all(): Promise<T[]>;
    find(id: any): Promise<T | null>;
    create(model: Partial<T>): Promise<CreateResult>;
    update(model: Partial<T>, ignoreFields?: (keyof T)[]): Promise<UpdateResult>;
    delete(id: any): Promise<DeleteResult>;
    search(query: any): Promise<T[] | null>;
}
