export declare type PaginationConfig = {
    page?: number;
    perPage?: number;
};
export declare type PaginationResult<T> = {
    firstPage: number;
    lastPage: number;
    data: T[];
    page: number;
    perPage: number;
    total: number;
};
export declare type Operator = '=' | '>' | '>=' | '<' | '<=' | '!=' | 'in' | 'not in' | 'between';
export interface IQueryBuilder<T> {
    where(field: keyof T, operator: Operator, value: any): any;
    sortBy(field: keyof T, order: 'ASC' | 'DESC'): any;
    paginate(config: PaginationConfig): any;
    get(): any;
}
