"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseManager = void 0;
const mongodb_1 = require("mongodb");
class DatabaseManager {
    static connect(config) {
        return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            try {
                const connection = new mongodb_1.MongoClient(config.url);
                yield connection.connect();
                this.db = connection.db(config.dbName);
                console.log(`- Connected to Mongo DB ${config.dbName}`);
                resolve(true);
            }
            catch (error) {
                reject(error);
            }
        }));
    }
    static get() {
        if (!this.db)
            throw new Error('MongoDB has not been initialized yet.');
        return this.db;
    }
}
exports.DatabaseManager = DatabaseManager;
DatabaseManager.db = undefined;
//# sourceMappingURL=DatabaseManager.js.map