import { ObjectId, Collection, ObjectID } from "mongodb";
import { CreateResult, DeleteResult, IOperation, UpdateResult } from "../definitions/IOperation";
import { Model } from "../model/Model";
export declare class Repo<T extends Model> implements IOperation<T> {
    private repo;
    constructor(collectionName: string);
    all(): Promise<T[]>;
    find(id: string | ObjectId): Promise<T | null>;
    create(model: Partial<T>): Promise<CreateResult>;
    update(model: Partial<T>, ignoreFields?: (keyof T)[]): Promise<UpdateResult>;
    delete(id: string | ObjectID): Promise<DeleteResult>;
    search(query: any): Promise<T[] | null>;
    raw(): Collection<T>;
}
export declare class RepoManager {
    private static repos;
    static get<T extends Model>(collectionName: string): Repo<any>;
}
