"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.belongsTo = void 0;
const mongodb_1 = require("mongodb");
const pluralize_1 = require("pluralize");
const stringHelper_1 = require("../helpers/stringHelper");
const QueryBuilder_1 = require("../model/QueryBuilder");
function belongsTo(self, relationship, localKey, foreignKey) {
    // @ts-ignore
    if (!localKey)
        localKey = `${stringHelper_1.lowerCaseFirst(pluralize_1.singular(relationship.cName))}Id`;
    if (!foreignKey)
        foreignKey = '_id';
    // @ts-ignore
    const builder = new QueryBuilder_1.QueryBuilder(relationship.cName, relationship, undefined, true);
    builder.where(foreignKey, '=', new mongodb_1.ObjectId(self[localKey]));
    return builder;
}
exports.belongsTo = belongsTo;
//# sourceMappingURL=BelongsTo.js.map