"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.belongsToMany = void 0;
const mongodb_1 = require("mongodb");
const pluralize_1 = require("pluralize");
const stringHelper_1 = require("../helpers/stringHelper");
const QueryBuilder_1 = require("../model/QueryBuilder");
function belongsToMany(self, relationship, pivot, localKey, foreignKey) {
    return __awaiter(this, void 0, void 0, function* () {
        // @ts-ignore
        if (!localKey)
            localKey = `${stringHelper_1.lowerCaseFirst(pluralize_1.singular(relationship.cName))}Id`;
        // @ts-ignore
        if (!foreignKey)
            foreignKey = `${stringHelper_1.lowerCaseFirst(pluralize_1.singular(relationship.cName))}Id`;
        // @ts-ignore
        const pivotBuilder = new QueryBuilder_1.QueryBuilder(pivot.cName, pivot);
        const pivotResult = yield pivotBuilder.where(localKey, '=', self._id).get();
        const relationshipIds = pivotResult.map((p) => new mongodb_1.ObjectId(p[foreignKey]));
        // @ts-ignore
        const builder = new QueryBuilder_1.QueryBuilder(relationship.cName, relationship);
        builder.where('_id', 'in', relationshipIds);
        return builder;
    });
}
exports.belongsToMany = belongsToMany;
//# sourceMappingURL=BelongsToMany.js.map