"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasMany = void 0;
const mongodb_1 = require("mongodb");
const pluralize_1 = require("pluralize");
const stringHelper_1 = require("../helpers/stringHelper");
const QueryBuilder_1 = require("../model/QueryBuilder");
function hasMany(self, relationship, localKey, foreignKey) {
    if (!localKey)
        localKey = '_id';
    // @ts-ignore
    if (!foreignKey)
        foreignKey = `${stringHelper_1.lowerCaseFirst(pluralize_1.singular(self.cName))}Id`;
    // @ts-ignore
    const builder = new QueryBuilder_1.QueryBuilder(relationship.cName, relationship);
    builder.where(foreignKey, '=', new mongodb_1.ObjectId(self[localKey]));
    return builder;
}
exports.hasMany = hasMany;
//# sourceMappingURL=HasMany.js.map